//
//  EmitterLayer.m
//  CAEmitterLayerDemo
//
//  Created by 张锋 on 16/6/28.
//  Copyright © 2016年 张锋. All rights reserved.
//

#import "EmitterLayer.h"
#import <QuartzCore/QuartzCore.h>

@interface EmitterLayer ()
@property (nonatomic, strong) CAEmitterLayer *emiLayer;

@end

@implementation EmitterLayer

//@property(nullable, copy) NSArray<CAEmitterCell *> *emitterCells;
//@property float birthRate;  粒子产生系数
//@property float lifetime;   粒子生命周期
//@property CGPoint emitterPosition;  放射位置
//@property CGFloat emitterZPosition;  发 射源的 z 坐 标 位置
//@property CGSize emitterSize; 放射大小
//@property CGFloat emitterDepth;  决定粒子形状的深度 联 系： emitter shape
//@property(copy) NSString *emitterShape; 放射形状
//@property(copy) NSString *emitterMode;  放射模式
//@property(copy) NSString *renderMode;   渲染模式
//@property BOOL preservesDepth;
//@property float velocity;  粒子速度
//@property float scale;   粒子的缩放比例
//@property float spin;  自旋转速度
//@property unsigned int seed;  用于初始化随机数产生的种子



//@property(nullable, copy) NSString *name;
//@property(getter=isEnabled) BOOL enabled; 粒子是否被渲染
//@property float birthRate;  粒子参数的速度乘数因子
//@property float lifetime; 生命周期
//@property float lifetimeRange; 生命周期范围
//@property CGFloat emissionLatitude; 发射的 z 轴方向的角度
//@property CGFloat emissionLongitude; x-y 平面的 发 射方向
//@property CGFloat emissionRange; 周 围发射角度
//@property CGFloat velocity; 速度
//@property CGFloat velocityRange;速度范围
//@property CGFloat xAcceleration; 粒子 x 方向的加速度分量
//@property CGFloat yAcceleration; 粒子 y 方向的加速度分量
//@property CGFloat zAcceleration; 粒子 z 方向的加速度分量
//@property CGFloat scale;  缩放比例
//@property CGFloat scaleRange;  缩放比例范围
//@property CGFloat scaleSpeed; 缩放比例速度
//@property CGFloat spin; 子旋转角度
//@property CGFloat spinRange; 子旋转角度范围
//@property(nullable) CGColorRef color;  粒子的颜色
//@property float redRange;  一个粒子的 颜 色 red 能改 变 的范 围
//@property float greenRange; 一个粒子的 颜 色 green 能改 变 的范 围
//@property float blueRange; 一个粒子的 颜 色 blue 能改 变 的范 围
//@property float alphaRange;  颜色改变范围
//@property float redSpeed; 粒子 red 在生命周期内的改变速度
//@property float greenSpeed; 粒子 green 在生命周期内的改变速度
//@property float blueSpeed;  粒子 blue 在生命周期内的改变速度
//@property float alphaSpeed;  透明度在生命周期内的改变速度
//@property(nullable, strong) id contents;  是个 CGImageRef 的对象 , 既粒子要展现的图片
//@property CGRect contentsRect;    应该画在 contents 里的子 rectangle
//@property CGFloat contentsScale;
//@property(copy) NSString *minificationFilter; 减小自己的大小
//@property(copy) NSString *magnificationFilter; 减小大小的因子
//@property float minificationFilterBias;
//@property(nullable, copy) NSArray<CAEmitterCell *> *emitterCells; 粒子发射的粒子
//@property(nullable, copy) NSDictionary *style;


- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupSubViews];
    }
    return self;
}

- (void)setupSubViews
{
    self.clipsToBounds = NO;
    self.userInteractionEnabled = NO; // 设置无法接受手势点击，否则按钮无法触发点击事件
    
    CAEmitterCell *emiCell = [CAEmitterCell emitterCell];
    emiCell.contents = (__bridge id)[UIImage imageNamed:@"Like-Sparkle"].CGImage;
    emiCell.name = @"thumb";
    emiCell.alphaRange = 0.2f;
    emiCell.alphaSpeed = -1.5f;
    emiCell.lifetime = 0.7f;
    emiCell.lifetimeRange = 0.3f;
    emiCell.birthRate = 0.0f;
    emiCell.velocity = 60.0f;
    emiCell.velocityRange = 10.0f;
    emiCell.emissionRange = M_PI_4;
    emiCell.scale = 0.05f;
    emiCell.scaleRange = 0.02f;
    
    _emiLayer = [CAEmitterLayer layer];
    _emiLayer.frame = self.bounds;
    _emiLayer.name = @"emitterLayer";
    _emiLayer.emitterShape = kCAEmitterLayerLine;
    _emiLayer.emitterMode = kCAEmitterLayerOutline;
    _emiLayer.emitterPosition = self.center;
    _emiLayer.emitterSize = CGSizeMake(20, 0);
    _emiLayer.renderMode = kCAEmitterLayerOldestLast;
    _emiLayer.masksToBounds = NO;
    _emiLayer.emitterCells = @[emiCell];
    [self.layer addSublayer:_emiLayer];
}

- (void)animation
{
    dispatch_time_t delay = dispatch_time(DISPATCH_TIME_NOW, 0.2 * NSEC_PER_SEC);
    dispatch_after(delay, dispatch_get_main_queue(), ^{
        self.emiLayer.beginTime = CACurrentMediaTime();
        CABasicAnimation *ani = [CABasicAnimation animationWithKeyPath:@"emitterCells.thumb.birthRate"];
        ani.fromValue = @(0);
        ani.toValue = @(500);
        [self.emiLayer addAnimation:ani forKey:nil];
    });
}

@end

