//
//  ThumbButton.h
//  ThumbButton
//
//  Created by 张锋 on 16/6/22.
//  Copyright © 2016年 张锋. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol ThumbButtonDelegate <NSObject>

@optional
/** 1、按钮被点击代理 */
- (void)thumbButtonClick;

@end

@interface ThumbButton : UIButton

/** 2、或者实现按钮点击回调方法 */
@property (nonatomic, copy) void (^buttonClick) (void);

/** 如果用代理，请设置代理 */
@property (nonatomic, assign) id<ThumbButtonDelegate> delegate;

@end
